class Panel::PersonalConference::Plugin::WritingConferencesController < OrbitBackendController
  include AdminHelper
  include OrbitControllerLib::DivisionForDisable
  
  before_filter :authenticate_user!

  before_filter :only => [ :new,:edit,:update] do |controller|
    controller.get_categorys('WritingConferenceCategory')
  end


  def index

  get_categorys("ConferencePaperType",params[:conference_paper_type_id])
  @filter = params[:filter]
  new_filter = params[:new_filter]

  if @filter && params[:clear]
    @filter.delete(params[:type])
  elsif @filter && new_filter
    if @filter.has_key?(new_filter[:type]) && @filter[new_filter[:type]].include?(new_filter[:id].to_s)
      @filter[new_filter[:type]].delete(new_filter[:id].to_s)
    elsif @filter.has_key?(new_filter[:type])
      @filter[new_filter[:type]] << new_filter[:id].to_s
    else
      @filter.merge!({new_filter[:type] => [new_filter[:id].to_s]})
    end
  elsif new_filter
    @filter = {new_filter[:type] => [new_filter[:id].to_s]}
  end
  @paper_types =  ConferencePaperType.all
  @paper_type_ids = @paper_types.collect{|t| t.id.to_s} + [nil]
  

	# @writing_conferences = WritingConference.search(params[:category_id])
	#@writing_conferences = (params[:sort] || @filter) ? get_sorted_and_filtered_writing_conferences : WritingConference.all.page(params[:page]).per(10)
  @writing_conferences = (params[:sort] || @filter) ? get_sorted_and_filtered("writing_conference",:create_user_id => current_user.id) : get_viewable("writing_conference", :create_user_id => current_user.id)

  @tags = get_tags

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @writing_conferences }
      format.js
    end
  end

  # GET /writing_conferences/1
  # GET /writing_conferences/1.xml
  def show
    @writing_conference = WritingConference.find(params[:id])
    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @writing_conference }
    end
  end

  # GET /writing_conferences/new
  # GET /writing_conferences/new.xml
  def new
  
    @writing_conference = WritingConference.new
    # @writing_conference_files = WritingConferenceFile.all
    # @level_types = ConferenceLevelType.all
    @author_types = ConferenceAuthorType.all
    @paper_types = ConferencePaperType.all
	
    @tags = get_tags

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @writing_conference }
    end
  end

  # GET /writing_conferences/1/edit
  def edit
    @writing_conference = WritingConference.find(params[:id])
	
    # @level_types = ConferenceLevelType.all
    @author_types = ConferenceAuthorType.all
    @paper_types = ConferencePaperType.all
	
    @tags = get_tags
  end

  # POST /writing_conferences
  # POST /writing_conferences.xml
  def create
	
    # @level_types = ConferenceLevelType.all
    @author_types = ConferenceAuthorType.all
    @paper_types = ConferencePaperType.all
	@tags = get_tags
  
    @writing_conference = WritingConference.new(params[:writing_conference])
	
    @writing_conference.create_user_id = current_user.id
    @writing_conference.update_user_id = current_user.id

    respond_to do |format|
      if @writing_conference.save
        format.html { redirect_to(panel_personal_conference_plugin_writing_conferences_url) }
        format.xml  { render :xml => @writing_conference, :status => :created, :location => @writing_conference }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @writing_conference.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /writing_conferences/1
  # PUT /writing_conferences/1.xml
  def update
    @writing_conference = WritingConference.find(params[:id])
	
    @writing_conference.update_user_id = current_user.id
	
	params[:writing_conference][:tag_ids] ||=[]

    respond_to do |format|
      if @writing_conference.update_attributes(params[:writing_conference])
        format.html { redirect_to(panel_personal_conference_plugin_writing_conferences_url) }
		# format.js  { render 'toggle_enable' }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @writing_conference.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /writing_conferences/1
  # DELETE /writing_conferences/1.xml
  def destroy
    @writing_conference = WritingConference.find(params[:id])
    @writing_conference.destroy

    respond_to do |format|
      format.html { redirect_to(panel_personal_conference_plugin_writing_conferences_url) }
      # format.xml  { head :ok }
      format.js
    end
  end

  def delete
    if params[:ids]
      writing_conferences = WritingConference.any_in(:_id => params[:ids]).destroy_all
    end
    redirect_to panel_personal_conference_plugin_writing_conferences_url(:direction => params[:direction], :sort => params[:sort], :sort_options => params[:sort_options])
  end
  
  protected
 

  # def get_index_categories(id = nil)
  #   @bulletin_categorys = []
  #   if(is_manager? || is_admin?)
  #     @bulletin_categorys = (id ? BulletinCategory.admin_manager_all.find(id).to_a : BulletinCategory.admin_manager_all)
  #   elsif is_sub_manager?
  #     @bulletin_categorys = BulletinCategory.all
  #   end
  #   @bulletin_categorys
  # end


  # def get_categorys(id = nil)
  #   @writing_conference_categorys = []
  #   if(is_manager? || is_admin?)
  #     @writing_conference_categorys = (id ? WritingConferenceCategory.admin_manager_all.find(id).to_a : WritingConferenceCategory.admin_manager_all))
  #   elsif is_sub_manager?
  #     @writing_conference_categorys = WritingConferenceCategory.all.authed_for_user(current_user,'edit')
  #   end
  #   if @writing_conference_categorys.empty? && params[:action] != "index"
  #       flash[:alert] = t("announcement.error.no_avilb_cate_for_posting")
  #       redirect_to :action => :index
  #   end
  # end
  
end
